<template>
  <div>
    <!-- Data URL -->
    <span v-if="editableDataUrl && currentFolderContent.type === 'Leaf'">
      <CoscineFormGroup
        :mandatory="true"
        label-for="dataUrl"
        :label="$t('page.resource.dataUrl')"
        :is-loading="showDetail && !currentFolderContent.dataUrl"
      >
        <b-input-group>
          <b-form-input
            id="dataUrl"
            :model-value="currentFolderContent.dataUrl"
            :placeholder="$t('page.resource.dataUrl')"
            :disabled="resource.archived || readOnly || isGuest"
            @update:modelValue="updateDataUrl"
          />
          <b-button id="URLBtn" :disabled="!isValidUrl" @click="openURL">
            <i-bi-link-45deg />
          </b-button>
        </b-input-group>
      </CoscineFormGroup>
    </span>

    <!-- Entry Name - Editable Key -->
    <span v-if="editableKey">
      <CoscineFormGroup
        :mandatory="true"
        label-for="metadataKey"
        :label="$t('page.resource.metadataKey')"
        :is-loading="showDetail && !currentFolderContent.name"
      >
        <template v-if="!isEntryNameUrlSafe" #hint>
          <span class="text-danger">{{
            $t("page.resource.urlSafeEntryNameHint")
          }}</span>
        </template>
        <template v-else #hint>
          {{ $t("page.resource.slashHint") }}
        </template>
        <b-form-input
          :model-value="currentFolderContent.name"
          :placeholder="$t('page.resource.metadataKey')"
          :disabled="resource.archived || readOnly || isGuest"
          @change="updateAbsolutePath"
          @update:model-value="currentEntryName = $event"
        />
      </CoscineFormGroup>
    </span>
  </div>
</template>

<script lang="ts">
import useProjectStore from "@/modules/project/store";

import type { FolderContent } from "@/modules/resource/types";
import type { ResourceDto } from "@coscine/api-client/dist/types/Coscine.Api";
import { validEntryName } from "@/modules/resource/utils/validators";

export default defineComponent({
  props: {
    currentFolderContent: {
      required: true,
      type: [Object] as PropType<FolderContent>,
    },
    editableDataUrl: {
      required: true,
      type: Boolean,
    },
    editableKey: {
      required: true,
      type: Boolean,
    },
    readOnly: {
      required: true,
      type: Boolean,
    },
    resource: {
      required: true,
      type: [Object] as PropType<ResourceDto>,
    },
    showDetail: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    const projectStore = useProjectStore();

    return {
      projectStore,
    };
  },
  data() {
    return {
      currentEntryName: "",
    };
  },
  computed: {
    isValidUrl(): boolean {
      if (
        !this.currentFolderContent ||
        (this.currentFolderContent && this.currentFolderContent.type === "Tree")
      ) {
        return false;
      }
      const dataUrl = this.currentFolderContent.dataUrl;
      if (dataUrl === undefined) {
        return false;
      }
      let url: URL;
      const validUrl =
        /^(http[s]?:\/\/){0,1}(www\.){0,1}[a-zA-Z0-9.-]+\.[a-zA-Z]{2,5}[.]{0,1}/;
      try {
        if (dataUrl.includes("://")) {
          url = new URL(dataUrl);
        } else {
          url = new URL("http://" + dataUrl);
        }
      } catch {
        return false;
      }
      return validUrl.test(url.toString());
    },
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    isEntryNameUrlSafe(): boolean {
      return validEntryName(this.currentFolderContent.name);
    },
  },
  methods: {
    openURL() {
      if (
        this.editableDataUrl &&
        this.currentFolderContent &&
        this.currentFolderContent.type === "Leaf"
      ) {
        let url = this.currentFolderContent.dataUrl;
        if (url !== undefined && !url.includes("://")) {
          url = "http://" + url;
        }
        const win = window.open(url, "_blank");
        if (win !== null) {
          win.focus();
        }
      }
    },
    updateDataUrl(value: string) {
      this.$emit("updateDataUrl", value);
    },
    updateAbsolutePath() {
      this.$emit("updateAbsolutePath", this.currentEntryName);
    },
  },
});
</script>
